package org.cebs.corep.excelToXbrl.constants;

/**
 * Constants for the templates MKR IM and MKR IM Daily - Day.
 */
public interface MKR_IM_ConstantsInterface
{
  /** Constants for the positions of the relevant cells/rows */
  public static final int ROWS_BEGIN_MKR_IM = 5;
  public static final int COLUMN_BEGIN_MKR_IM = 3;

  public static final int ROWS_BEGIN_MKR_DAILY_DAY = 11;
  public static final int COLUMN_BEGIN_MKR_DAILY_DAY = 2;

  public static final int ROW_BEGIN_MKR_DAILY_BASIC = 6;

  /** Constants for the dimension name */
  public static final String DIMENSIONNAMEMARKETRISKFACTORS = "t-mi-2005-12-31.xsd#t-mi_MarketRiskBreakdownDimension";

  /** Constant for the context */
  public static final String CONTEXT_PART = "cxt_t-mi_";

  /** Constants for the measures (element names) */
  public static final String MULTIPLICATIONFACTORXAVERAGEPREVIOUS60WORKINGDAYSVAR = "MultiplicationFactorXAveragePrevious60WorkingDaysVaR";
  public static final String PREVIOUSDAYVAR = "PreviousDayVaR";
  public static final String SPECIFICRISKSURCHARGE = "SpecificRiskSurcharge";
  public static final String INCREMENTALDEFAULTRISKSURCHARGE = "IncrementalDefaultRiskSurcharge";
  public static final String CAPITALREQUIREMENTS = "CapitalRequirements";
  public static final String NUMBEROVERSHOOTINGS = "NumberOfOvershootingsDuringPrevious250WorkingDays";
  public static final String MULTIPLICATIONFACTOR = "MultiplicationFactor";

  /** Constants for the dimensions (element names) of template MR (Internal Models Overview -Templates */
  public static final String TRADEDDEBTINSTRUMENTS = "TradedDebtInstruments";
  public static final String TRADEDDEBTINSTRUMENTSGENERALRISK = "TDIGeneralRisk";
  public static final String TRADEDDEBTINSTRUMENTSSPECIFICRISK = "TDISpecificRisk";
  public static final String EQUITIES = "Equities";
  public static final String EQUITIESGENERALRISK = "EquitiesGeneralRisk";
  public static final String EQUITIESSPECIFICRISK = "EquitiesSpecificRisk";
  public static final String FOREIGNEXCHANGERISK = "ForeignExchangeRisk";
  public static final String COMMODITYRISK = "CommodityRisk";
  public static final String TOTALAMOUNTGENERALRISK = "TotalAmountForGeneralRisk";
  public static final String TOTALAMOUNTSPECIFICRISK = "TotalAmountForSpecificRisk";

  /** Constants for the measures (element names) of template MR (Internal Models. Additional and Daily Information) */
  public static final String VART10 = "VaRT10";
  public static final String VART1 = "VaRT1";
  public static final String SPECIFICRISKSURCHAGE = "SpecificRiskSurcharge";
  public static final String INCREMENTALDEFAULTRISKSURCHARGE2 = "IncrementalDefaultRiskSurcharge";
  public static final String INTERNALVAR = "InternalVaR";
  public static final String INTERNALVARLIMIT = "InternalVaRLimit";
  public static final String HYPOTHETICALPL = "Hypothetical";
  public static final String ACTUAL = "Actual";

  /** Constants for the implizit Dimensions */
  public static final String DAY = "Day";
  public static final String BASICINFORMATION = "BasicInformation";
  public static final String INSTRUMENTCODE = "InstrumentCodeRegulatoryModel";
  public static final String SPECIFICRISKEQUITIESCALCULATIONCODE = "SpecificRiskEquitiesCalculationCode";
  public static final String SPECIFICRISKDEBTINSTRUMENTCALCULATIONCODE = "SpecificRiskDebtInstrumentsCalculationCode";
  public static final String PLCALCULATIONNUMBEROVERSHOOTINGS = "PLCodeUsedForCalculationNumberOvershootings";
  public static final String CONFIDENCEINTERVALINTERNALVAR = "ConfidenceIntervalInternalVaR";
  public static final String HOLDINGPERIODINTERNALVAR = "HoldingPeriodInternalVaR";

}