package org.cebs.corep.excelToXbrl.constants;

/**
 * Constants for the templates OPR and OPR-Loss.
 */
public interface OPR_ConstantsInterface
{
  /** Constants for the positions of the relevant cells/rows */
  public static final int ROWS_BEGIN_OPR = 7;
  public static final int ROWS_END_OPR = 22;
  public static final int COLUMN_BEGIN_OPR = 2;
  public static final int ROWS_BEGIN_OPR_DETAILS = 4;
  public static final int COLUMN_BEGIN_OPR_DETAILS = 3;
  public static final int COLUMN_END_OPR_DETAILS = 13;
	public static final int ROWS_BEGIN_OPR_LOSS = 5;

  /** Constants for the dimension names */
  public static final String BANKINGACTIVITIESDIMENSION = "BankingActivitiesDimension";
  public static final String BUSINESSLINESDIMENSION = "BusinessLinesDimension";
  public static final String BUSINESSLINESDIMENSION2 = "BusinessLineDimension";
  public static final String EVENTTYPEDIMENSION = "EventTypeDimension";
	public static final String INTERNALREFERENCENUMBERDIMENSION = "InternalReferenceNumber";
  public static final String THRESHOLDAPPLIEDINDATACOLLECTIONDIMENSION = "t-od-2005-12-31.xsd#t-od_ThresholdAppliedInDataCollectionDimension";

  /** Constants for the context */
  public static final String CONTEXT_PART = "cxt_";

  /** Constants for the measures (element names) of template t-op*/
  public static final String YEAR3GI = "Year3GrossIncome";
  public static final String YEAR2GI = "Year2GrossIncome";
  public static final String LASTYEARGI = "LastYearGrossIncome";
  public static final String YEAR3LA = "Year3LoansAdvances";
  public static final String YEAR2LA = "Year2LoansAdvances";
  public static final String LASTYEARLA = "LastYearLoansAdvances";
  public static final String CAPITALREQUIREMENTS = "CapitalRequirements";
  public static final String OFWHICHALLOCATIONMECHANISM = "OfWhichAllocationMechanism";
  public static final String CAPITALREQUIREMENTSBEFOREALLEVIATION = "CapitalRequirementsBeforeAlleviation";
  public static final String ALLEVIATIONCAPITALREQUIREMENTSCAPTUREDINBUSINESSPRACTICES = "AlleviationCapitalRequirementsCapturedInBusinessPractices";
  public static final String ALLEVIATIONCAPITALREQUIREMENTSRISKTRANSFERMECHANISMS = "AlleviationCapitalRequirementsRiskTransferMechanisms";
  public static final String OFWHICHDUEINSURANCE = "OfWhichDueInsurance";
  public static final String EXCESSONLIMITCAPITALALLEVIATION = "ExcessOnLimitCapitalAlleviation";

  /** Constants for the dimensions (element names) of template t-op */
  public static final String TOTALBANKINGACTIVITIESSUBJECTTOBIA = "TotalBankingActivitiesSubjectBIA";
  public static final String TOTALBANKINGACTIVITIESSUBJECTSTAALTERNATIVE = "TotalBankingActivitiesSubjectSTAAlternative";
  public static final String CORPORATEFINANCE = "CorporateFinance";
  public static final String TRADINGANDSALES = "TradingSales";
  public static final String RETAILBROKERAGE = "RetailBrokerage";
  public static final String COMMERCIALBANKING = "CommercialBanking";
  public static final String RETAILBANKING = "RetailBanking";
  public static final String PAYMENTANDSETTLEMENT = "PaymentSettlement";
  public static final String AGENCYSERVICES = "AgencyServices";
  public static final String ASSETMANAGEMENT = "AssetManagement";
  public static final String TOTALBANKINGACTIVITIESSUBJECTASA = "TotalBankingActivitiesSubjectASA";
  public static final String TOTALBANKINGACTIVITIESSUBJECTSTA = "TotalBankingActivitiesSubjectSTA";
  public static final String TOTALBANKINGACTIVITIESSUBJECTTOAMA = "TotalBankingActivitiesSubjectAMA";

  /** Constants for the measures (element names) of template t-od*/
  public static final String NUMBEREVENTS = "NumberOfEvents";
  public static final String TOTALLOSSAMOUNT = "TotalLossAmount";
  public static final String MAXIMUMSINGLELOSS = "MaximumSingleLoss";

  /** Constants for the dimensions (element names) of template t-od */
  public static final String INTERNALFRAUD = "InternalFraud";
  public static final String EXTERNALFRAUD = "ExternalFraud";
  public static final String EMPLOYMENTPRACTICESWORKPLACESAFETY = "EmploymentPracticesAndWorkplaceSafety";
  public static final String CLIENTSPRODUCTSBUSINESSPRACTICES = "ClientsProductsBusinessPractices";
  public static final String DAMAGEPHYSICALASSETS = "DamageToPhysicalAssets";
  public static final String BUSINESSDISRUPTIONSYSTEMFAILURES = "BusinessDisruptionAndSystemFailures";
  public static final String EXECUTIONDELIVERYPROCESSMANAGEMENT = "ExecutionDeliveryProcessManagement";
  public static final String TOTAL = "Total";

  public static final String LOWEST = "Lowest";
  public static final String HIGHEST = "Highest";

  /** Constants for the measures (element names) of template t-ol*/
  public static final String GROSSLOSSAMOUNT = "GrossLossAmount";
	public static final String OFWHICHUNREALIZED ="OfWhichUnrealized";
  public static final String STATUS = "Status";
  public static final String LOSSALREADYDIRECTLYRECOVERED = "LossAlreadyDirectlyRecovered";
  public static final String LOSSALREADYRECOVEREDFROMRISKTRANSFERMECHANISMS = "LossAlreadyRecoveredFromRiskTransferMechanisms";
  public static final String LOSSPOTENTIALLYTOBERECOVEREDDIRECTLYORFROMRISKTRANSFERMECHANISMS = "LossPotentiallyToBeRecoveredDirectlyOrFromRiskTransferMechanisms";
  public static final String RELATEDTOCRORMKR = "RelatedToCROrMKR";
  public static final String TRADINGSALES = "TradingSales";
  public static final String PAYMENTSETTLEMENT = "PaymentSettlement";
  public static final String RISKEVENTTYPE = "RiskEventType";
  public static final String OCURRENCE = "Ocurrence";
  public static final String RECOGNITION = "Recognition";
  public static final String FIRSTPAYMENTFROMRISKTRANSFERMECHANISMS = "FirstPaymentFromRiskTransferMechanisms";
  public static final String LATESTPAYMENTFROMRISKTRANSFERMECHANISMS = "LatestPaymentFromRiskTransferMechanisms";
}