package org.cebs.corep.excelToXbrl.mapper;

import java.util.HashMap;

/**
 * This class defines a HashMap that contains the name of the exposure class
 * element names and their keys as defined in the coreptest.xlt.
 * <br />
 */
public class ExposureClassMapper
{
  private final static ExposureClassMapper exposureClassMapper = new ExposureClassMapper();
  private HashMap exposureClassMap = new HashMap();

  /**
   * Private constructor
   */
  private ExposureClassMapper()
  {
    exposureClassMap.put("1", "CentralGovernmentsCentralBanks");
    exposureClassMap.put("11", "CentralRegionalGovernmentsLocalAuthorities");
    exposureClassMap.put("12", "OtherCentralGovernmentCentralBanks");
    exposureClassMap.put("2", "Institutions");
    exposureClassMap.put("21", "InstitutionsRegionalGovernmentsLocalAuthorities");
    exposureClassMap.put("22", "InstitutionsAdministrativeBodiesNonCommercialUndertakings");
    exposureClassMap.put("23", "OtherInstitutions");
    exposureClassMap.put("3", "Corporate");
    exposureClassMap.put("31", "CorporateAdministrativeBodiesNonCommercialUndertakings");
    exposureClassMap.put("32", "SpecializedLending");
    exposureClassMap.put("321", "SlottingCriteria ");
    exposureClassMap.put("322", "ExcludingSlottingCriteria");
    exposureClassMap.put("33", "OtherCorporate");
    exposureClassMap.put("331", "CorporatePurchasedReceivables");
    exposureClassMap.put("332", "CorporateExcludingPurchasedReceivables");
    exposureClassMap.put("34", "CorporateOfWhichSME");
    exposureClassMap.put("341", "CorporateSMEPurchasedReceivables");
    exposureClassMap.put("342", "CorporateSMEExcludingPurchasedReceivables");
    exposureClassMap.put("4", "Retail");
    exposureClassMap.put("41", "RetailSecuredRealEstate");
    exposureClassMap.put("42", "QualifyingRevolving");
    exposureClassMap.put("421", "RetailPurchasedReceivables");
    exposureClassMap.put("422", "RetailExcludingPurchasedReceivables");
    exposureClassMap.put("43", "OtherRetail");
    exposureClassMap.put("431", "OtherRetailPurchasedReceivables");
    exposureClassMap.put("432", "OtherRetailExcludingPurchasedReceivables");
    exposureClassMap.put("44", "RetailOfWhichSME");
    exposureClassMap.put("441", "RetailSMESecuredRealEstate");
    exposureClassMap.put("442", "SMEOtherRetail");
    exposureClassMap.put("4421", "SMERetailPurchasedReceivables");
    exposureClassMap.put("4422", "SMERetailExcludingPurchasedReceivables");
    exposureClassMap.put("Total", "Total");
  }

  /**
   * Returns an object of type ExposureClassMapper
   * @return ExposureClassMapper
   */
  public static ExposureClassMapper getInstance()
  {
    return exposureClassMapper;
  }

  /**
   * Returns a hashMap filled with exposure class values.
   * @return
   */
  public HashMap getExposureClassMap()
  {
    return exposureClassMap;
  }
}
