package org.cebs.corep.forms;

import java.util.ArrayList;
import java.util.HashMap;

import org.apache.struts.upload.FormFile;
import org.cebs.corep.xbrl.action.CorepActionForm;
import org.jdom.Document;

/** 
 * JSP-JavaBean for the transmission of the concent of this bean into the business logic.
 * <br />
 * 
 * @author Katrin Schmehl
 */
public class CorepForm extends CorepActionForm
{
  private FormFile uploadedFile = null; // file, that has to be transformed
  private String errorMessage = null; // content of an error
  private Document jdomDocument = null; // content of the xbrl instance as xml representation
  private String validationLevel = null; // level of validation to choose
  private ArrayList result = null; // object that contains the result of the xbrl validation
  private String fileName = null; // name of the file
  private String referenceNumber = null; // number of the company
  private String instanceDate = null; // instant date of the instance
  private String country = null;

  /**
   * Constructor fr die CorepForm.
   */
  public CorepForm()
  {
    super();
    validationLevel = "schema";
  }

  /**
   * @return
   */
  public FormFile getUploadedFile()
  {
    return uploadedFile;
  }

  /**
   * @param file
   */
  public void setUploadedFile(FormFile file)
  {
    uploadedFile = file;
  }
  /**
   * @return
   */
  public String getErrorMessage()
  {
    return errorMessage;
  }

  /**
   * @param string
   */
  public void setErrorMessage(String string)
  {
    errorMessage = string;
  }

  /**
   * @return
   */
  public Document getJdomDocument()
  {
    return jdomDocument;
  }

  /**
   * @param document
   */
  public void setJdomDocument(Document document)
  {
    jdomDocument = document;
  }

  /**
   * @return
   */
  public ArrayList getResult()
  {
    return result;
  }

  /**
   * @param results
   */
  public void setResult(ArrayList results)
  {
    result = results;
  }

  /**
   * @return
   */
  public String getValidationLevel()
  {
    return validationLevel;
  }

  /**
   * @param string
   */
  public void setValidationLevel(String string)
  {
    validationLevel = string;
  }

  /**
   * @return
   */
  public String getFileName()
  {
    return fileName;
  }

  /**
   * @param string
   */
  public void setFileName(String string)
  {
    fileName = string;
  }

  /**
   * @return
   */
  public String getInstanceDate()
  {
    return instanceDate;
  }

  /**
   * @return
   */
  public String getReferenceNumber()
  {
    return referenceNumber;
  }

  /**
   * @param string
   */
  public void setInstanceDate(String string)
  {
    instanceDate = string;
  }

  /**
   * @param string
   */
  public void setReferenceNumber(String string)
  {
    referenceNumber = string;
  }

  /**
   * @return
   */
  public String getCountry()
  {
    return country;
  }

  /**
   * @param string
   */
  public void setCountry(String string)
  {
    country = string;
  }

}