package org.cebs.corep.xbrl.action;

import java.io.IOException;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;

import javax.ejb.CreateException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.Status;
import javax.transaction.SystemException;
import javax.transaction.UserTransaction;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.cebs.corep.xbrl.exceptions.CorepBusinessException;
import org.cebs.corep.xbrl.exceptions.CorepPropertyNotFoundException;
import org.cebs.corep.xbrl.log.LogAction;
import org.cebs.corep.xbrl.util.CorepClientContext;
import org.cebs.corep.xbrl.util.CorepProperties;
import org.xml.sax.SAXException;

import de.bundesbank.util.log.ClientContext;
import de.bundesbank.util.webgui.struts.BasisActionServlet;
import de.bundesbank.util.webgui.struts.Statics;

/**
 * Initialisiert die Anwendung durch Aufruf der Code-Tabellen 
 * und Einlesen der Properties
 */
public class InitAction extends CorepAction
{

  private ClientContext myClientContext;

  /**
   * @see BasisAction#getIClientContext()
   */
  protected de.bundesbank.util.log.ClientContext getIClientContext()
  {
    if (myClientContext != null)
      return myClientContext;
    else
      return super.getIClientContext();
  }

  public void prepareForServletUse()
  {
    myClientContext = new CorepClientContext();
  }

  /**
   * Kein Reset implementiert
   * 
   * @see BakisAction#performReset(ActionMapping, ActionForm, HttpServletRequest, HttpServletResponse)
   */
  public void performReset(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)
  {
  }

  /**
   * Initialisierung der Anwendung.
   *  
   * @see BakisAction#performAction(ActionMapping, ActionForm, HttpServletRequest, HttpServletResponse)
   */
  public void performAction(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws CorepBusinessException, RemoteException
  {
    String methodName = "performAction";
    log(LogAction.METHOD_BEGIN, getClass().getName(), methodName);
    try
    {
      performInit();
      request.setAttribute("return", "true");
      request.setAttribute("info", "EuroEvidenz WebInitialisierung erfolgreich");
      request.setAttribute("error", "");
    }
    catch (Exception e)
    {
      request.setAttribute("error", "Fehler bei der WebInitialisierung von EuroEvidenz");
      log("ANWENDUNGINIT_ERROR", getClass().getName(), methodName, e);
      throw new CorepBusinessException("Fehler bei der Web-Initialiserung von EuroEvidenz", e);
    }
    log(LogAction.METHOD_END, this.getClass().getName(), methodName);
  }

  /**
   * Einlesen der Properties und Initialisierung der Codetabellen
   * 
   */
  public void performInit()
    throws CorepPropertyNotFoundException, NamingException, SQLException, ServletException, IOException, SAXException, SecurityException, IllegalStateException, RollbackException, HeuristicMixedException, HeuristicRollbackException, NotSupportedException, SystemException
  {
    String methodName = "performInit";

    Statics.ACTION_ROUTER = "Router.start";
  }
}
