package org.cebs.corep.xbrl.exceptions;

import java.io.PrintWriter;
import java.io.Serializable;
import java.io.StringWriter;

/**
 * Diese Klasse wurde von IT 472 in Bakis-M erstellt und in diese Projekt bernommen.
 * Sie ist Oberklasse aller spezifischen Projekt-Exception-Klassen.
 */
public class BasisException extends Exception implements Serializable
{
  private Object[] _objects = null;
  private Throwable _detail = null;

  //Konstruktoren

  public BasisException()
  {
    super();
  }

  /**
   * @param s String
   */
  public BasisException(String s)
  {
    super(s);
  }

  /**
   * @param s String
   * @param oa Object[]
   */
  public BasisException(String s, Object[] oa)
  {
    super(s);
    _objects = oa;
  }

  /**
   * @param s String
   * @param e Throwable
   */
  public BasisException(String s, Throwable e)
  {
    super(s);
    _detail = e;
  }

  /**
   * @param s String
   * @param e Throwable
   * @param oa Object[]
   */
  public BasisException(String s, Throwable e, Object[] oa)
  {
    super(s);
    _objects = oa;
    _detail = e;
  }

  /**
   * @param e Throwable
   */
  public BasisException(Throwable e)
  {
    super();
    _detail = e;
  }

  /**
   * @return Throwable
   */
  public Throwable getDetail()
  {
    return _detail;
  }

  /**
   * @return Object[]
   */
  public Object[] getObjects()
  {
    return _objects;
  }

  /**
   * @return String
   */
  public String toString()
  {
    String s = super.toString();
    if (_detail != null)
    {
      s += "\n\tdetail: " + _detail;
    }
    return s;
  }

  /**
   * Liefert den Aufrufstapel einer Ausnahme als Zeichenkette.
   * @param th Throwable
   * @return String
   */
  private String getStack(Throwable th)
  {
    String stack = "";

    if (th != null)
    {
      StringWriter w = new StringWriter();
      th.printStackTrace(new PrintWriter(w));
      stack = w.getBuffer().toString();
    }

    return stack;
  }
  
  /**
   * berschreibt die  Methode: printStackTrace(PrintStream).
   *
   * @param  PrintStream ps   
   *
   * @author  Thomas Brll
   * @version 1.0
   */
  public void printStackTrace(java.io.PrintStream ps)
  {
    if (_detail == null)
    {
      super.printStackTrace(ps);
    }
    else
    {
      synchronized (ps)
      {
        super.printStackTrace(ps);
        ps.println(_detail);
      }
    }
  }
  
  /**
   * berschreibt die  Methode: printStackTrace(PrintWriter).
   *
   * @param   PrintWriter pw 
   *
   * @author  Thomas Brll
   * @version 1.0
   */
  public void printStackTrace(java.io.PrintWriter pw)
  {
    if (_detail == null)
    {
      super.printStackTrace(pw);
    }
    else
    {
      synchronized (pw)
      {
        super.printStackTrace(pw);
        pw.println(_detail);
      }
    }
  }
}
